# -*- coding: utf-8 -*-

#3a) Si scriva una funzione positions(pdbfile) che, con riferimento a un file 
# PDB CHE CONTIENE UNA SOLA CATENA, trovi per ciascun residuo quali sono le 
# coordinate del relativo carbonio alfa (come array numpy).
# L'output dovrà perciò essere una lista di vettori.
# Indicazione: se p è una istanza della classe Bio.PDB.Polypeptide.Polypeptide,
# il suo residuo i-esimo si ottiene come p[i]. Se r è una istanza della classe 
# Bio.PDB.Residue, il suo carbonio alfa si ottiene come r["CA"]. 
# Se a è una istanza della classe Bio.PDB.Atom, le sue coordinate si ottengono 
# tramite il metodo get_coord().


from Bio.PDB.PDBParser import PDBParser
from Bio.PDB.Polypeptide import PPBuilder

       
def positions(pdbfile):
    
    struct1 = PDBParser().get_structure('CONF1', pdbfile)    
    nchains1 = list(struct1.get_chains())
    if nchains1:
        if len(nchains1)!=1:
            raise ValueError  
    else:
        raise ValueError
        
    ppeps = PPBuilder().build_peptides(struct1) #list of polypeptides
    ppep = ppeps[0] #the first polypeptyde (the only one)
    
    return [res["CA"].get_coord() for res in ppep] #vector w/ positions of CAs
