# -*- coding: utf-8 -*-

#4a) Si scriva una funzione nearest(pdbfile) che, con riferimento a un file 
# PDB CHE CONTIENE UNA SOLA CATENA, trovi per ciascun residuo qual'è l'indice
# dell'altro residuo della catena ad esso più vicino (escludendo quelli ad 
# esso adiacenti sul backbone). Come centro ideale di un residuo si assuma 
# la posizione del suo carbonio alfa.
# L'output dovrà essere una lista di interi, in cui in posizione i-esima 
# compaia il valore dell'indice del residuo più vicino all'i-esimo.


from soluzione3 import positions
import numpy as np


def nearest(pdbfile):
    
    def dist(x,y):
        "Euclidean distance"
        d = x-y
        return np.sqrt(d.dot(d))
    
    poss = positions(pdbfile)
    
    output = []
    for i, p0 in enumerate(poss):
        target, curr_min = None, 0      
        for j, p1 in enumerate(poss):
            if np.abs(i-j)>1:     #we skip adjacent residues
                d = dist(p0,p1)
                if not target or d < curr_min:
                    target, curr_min = j, d
        output.append(target)
        
    return output
        
